--- nagios-2.12/base/utils.c	2008-02-10 17:20:10.000000000 +0000
+++ nagios-2.12.new/base/utils.c	2009-02-26 21:01:01.000000000 +0000
@@ -2684,11 +2684,33 @@
 #endif 
 
 	/* create a pipe */
-	pipe(fd);
+	if (pipe(fd) == -1){
+	  snprintf(buffer, sizeof(buffer)-1, "Warning: pipe() in my_system() failed (%s) for command \"%s\"\n", strerror(errno), cmd);
+	  buffer[sizeof(buffer)-1]='\x0';
+
+	  if(output!=NULL){
+	    strncpy(output,buffer,output_length-1);
+	    output[output_length-1]='\x0';
+	  }
+
+	  write_to_logs_and_console(buffer,NSLOG_RUNTIME_WARNING,TRUE);
+
+	  return STATE_UNKNOWN;
+	}
 
 	/* make the pipe non-blocking */
-	fcntl(fd[0],F_SETFL,O_NONBLOCK);
-	fcntl(fd[1],F_SETFL,O_NONBLOCK);
+	if (fcntl(fd[0],F_SETFL,O_NONBLOCK) == -1) {
+	  /* failure is not a fatal error but should be logged */
+	  snprintf(buffer, sizeof(buffer)-1, "Warning: fcntl(F_SETFL, O_NONBLOCK) in my_system() failed (%s) for command \"%s\"\n", strerror(errno), cmd);
+	  buffer[sizeof(buffer)-1]='\x0';
+	  write_to_logs_and_console(buffer,NSLOG_RUNTIME_WARNING,TRUE);
+	}
+	if (fcntl(fd[1],F_SETFL,O_NONBLOCK) == -1) {
+	  /* failure is not a fatal error but should be logged */
+	  snprintf(buffer, sizeof(buffer)-1, "Warning: fcntl(F_SETFL, O_NONBLOCK) in my_system() failed (%s) for command \"%s\"\n", strerror(errno), cmd);
+	  buffer[sizeof(buffer)-1]='\x0';
+	  write_to_logs_and_console(buffer,NSLOG_RUNTIME_WARNING,TRUE);
+	}
 
 	/* get the command start time */
 	gettimeofday(&start_time,NULL);
@@ -2706,7 +2728,7 @@
 	/* return an error if we couldn't fork */
 	if(pid==-1){
 
-		snprintf(buffer,sizeof(buffer)-1,"Warning: fork() in my_system() failed for command \"%s\"\n",cmd);
+		snprintf(buffer,sizeof(buffer)-1,"Warning: fork() in my_system() failed (%s) for command \"%s\"\n",strerror(errno),cmd);
 		buffer[sizeof(buffer)-1]='\x0';
 
 		if(output!=NULL){
